// Outline.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=6

#version 150
//#extension GL_EXT_geometry_shader4 : enable
//#extension GL_EXT_gpu_shader4 : enable
// geometry shader of carttond shading

layout (triangles) in;
layout (triangle_strip, max_vertices = 6) out;

uniform float     boldness;

//in
in vec3 modelview_positionIn[];
in vec4 modelview_positionIn4[];
in vec4 positionIn4[];
in vec2 texCoordIn[];
in vec3 normalIn[];
in vec4 GLSubPosition[];

//out
out float t;
out vec3 modelview_position;
out vec4 modelview_position4;
out vec3 normal;
out vec2 gsTexCoord;


void main(void)
{
    //int length = gl_TexCoordIn.length();
    int length = gl_in.length(); // TRIANGLE なので 3 固定で良い？

    for(int i = 0; i < length; i++){
	gsTexCoord = texCoordIn[i];
	gl_Position = positionIn4[i];
	t = 1;
	modelview_position  = modelview_positionIn[i];
	modelview_position4 = modelview_positionIn4[i];
	normal = normalIn[i];
	EmitVertex();
    }
    EndPrimitive();

    if (boldness != 0){
	for(int i =  length-1; i >= 0; i--){
	    gl_Position = GLSubPosition[i];
	    t = 0;
	    EmitVertex();
	}
	EndPrimitive();
    }
}
