// Outline.vert

#version 130

uniform float boldness;

out vec3 modelview_positionIn;
out vec4 modelview_positionIn4;
out vec4 positionIn4;
out vec2 texCoordIn;
out vec3 normalIn;
out vec4 GLSubPosition;

void main(void)
{
    gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;//ftransform();

    modelview_positionIn = vec3(gl_ModelViewMatrix * gl_Vertex);
    modelview_positionIn4 = gl_ModelViewMatrix * gl_Vertex;
    positionIn4 = gl_ModelViewProjectionMatrix * gl_Vertex;
    
    float distance = gl_Position.z;
    GLSubPosition = gl_Vertex + vec4(gl_Normal, 0) * 0.2 * boldness * sqrt(distance);
    GLSubPosition = gl_ModelViewProjectionMatrix * GLSubPosition;

    texCoordIn = gl_TexCoord[0].st;
    normalIn = gl_NormalMatrix * gl_Normal;
}
